import(Module_Commands)
import(Module_Control)
import(Module_DataTypes)
import(Module_Defines)
import(Module_Draw)
import(Module_Game)
import(Module_GameStates)
import(Module_Globals)
import(Module_Helpers)
import(Module_Level)
import(Module_Map)
import(Module_MapWho)
import(Module_Objects)
import(Module_Person)
import(Module_Players)
import(Module_PopScript)
import(Module_System)
import(Module_Sound)
import(Module_Table)

MagicShield = {tribe = 0}
MagicShield.__index = MagicShield

--ShieldCount is 1.5x the seconds.
function MagicShield:new(o, thing, originalMaxHealth, shieldCount)
	local o = o or {}
	setmetatable(o, MagicShield)

	o.thing = thing
	o.originalMaxHealth = originalMaxHealth
	o.timeLeftInSeconds = math.floor(shieldCount / 1.5)

	return o
end

--handle duration of shield so that max health and steel boots get readded/removed properly.
function MagicShield:handleShield()
	if (everyPow(12, 1)) then
		self.timeLeftInSeconds = self.timeLeftInSeconds - 1
	end

	if (self.thing.u.Pers.Life <= self.originalMaxHealth or self.timeLeftInSeconds <= 0) then
		self:removeShield()
	end
end

--Reset max life to what it was before, make sure the shield flag gets removed.
function MagicShield:removeShield()
	if (self.thing ~= nil) then
		self.thing.u.Pers.MaxLife = self.originalMaxHealth

		if (self.thing.u.Pers.Life > self.originalMaxHealth) then
			self.thing.u.Pers.Life = self.originalMaxHealth
		end

		self.thing.Flags3 = self.thing.Flags3 ~ TF3_SHIELD_ACTIVE
		self.thing.u.Pers.u.Owned.ShieldCount = 0
		self.thing.Flags2 = self.thing.Flags2 | TF2_EXTERNALLY_MOVEABLE
		self.thing.u.Pers.OnDamage:clear()
	end

	DeleteMagicShieldFromList(self)
end

function MagicShield:getShieldByPosition(D2Pos)
	if (self.thing ~= nil) then
		local c2d = Coord2D.new()
		coord3D_to_coord2D(self.thing.Pos.D3, c2d)

		if (get_world_dist_xz(D2Pos, c2d) < 32) then
			return self
		end
	end

	return nil
end