import(Module_DataTypes)
import(Module_Globals)
import(Module_Players)
import(Module_Table)

_gsi = gsi()
_sti = scenery_type_info()
_spti = spells_type_info()
_c = constants()

function EnableSpellCharging(_pn, _spell)
  _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsNotCharging = _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsNotCharging ~ (1<<_spell-1)
end

function DisableSpellCharging(_pn, _spell)
  _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsNotCharging = _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsNotCharging | (1<<_spell-1)
end

function EnableSpell(_pn, _spell)
  _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable = _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable | (1 << _spell)
end

function DisableSpell(_pn, _spell)
  _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable = _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsAvailable ~ (1 << _spell)
end

function SetOneShotCharges(_pn, _spell, _num)
  _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsAvailableOnce[_spell] = _gsi.ThisLevelInfo.PlayerThings[_pn].SpellsAvailableOnce[_spell] | _num
end

function ResetSpellsCharging()
  for j = 0, 7 do
    for i = 0, 21 do
      if (i ~= 2 and i ~= 17) then
        DisableSpellCharging(j, i)
      end
    end
  end
end

function EnableBuilding(_pn, _building)
	 _gsi.ThisLevelInfo.PlayerThings[_pn].BuildingsAvailable = _gsi.ThisLevelInfo.PlayerThings[_pn].BuildingsAvailable | (1 << _building)
end

function DisableBuilding(_pn, _building)
	_gsi.ThisLevelInfo.PlayerThings[_pn].BuildingsAvailable = _gsi.ThisLevelInfo.PlayerThings[_pn].BuildingsAvailable ~ (1 << _building)
end

function GetTurn()
  return _gsi.Counts.GameTurn
end

function GetPlayerPeople(pn)
  return _gsi.Players[pn].NumPeople
end

function randSign()
  local a = -1
  if (G_RANDOM(2) == 0) then
    a = 1
  end
  return a
end

function everyPow(a,b)
  if (_gsi.Counts.GameTurn % a^b == 0) then
    return true else return false
  end
end

function every2Pow(a)
  if (_gsi.Counts.GameTurn % 2^a == 0) then
    return true else return false
  end
end

function DoesExist(table,input)
  for i,v in ipairs(table) do
    if (v == input) then
      return true
    end
  end

  return false
end

function GetPopLeader()
  local plr_pops = {}
  for i=0,7 do
    local pop = GetPlayerPeople(i)
    table.insert(plr_pops,pop)
  end

  local max = plr_pops[1];
  maxIndex = 1;

  for i,v in ipairs(plr_pops) do
    if (v > max) then
      maxIndex = i
      max = plr_pops[i]
    end
  end
  return maxIndex-1;
end

function tablelength(te)
  local count = 0
  for _ in pairs(te) do count = count + 1 end
  return count
end
