import(Module_Commands)
import(Module_Control)
import(Module_DataTypes)
import(Module_Defines)
import(Module_Draw)
import(Module_Game)
import(Module_GameStates)
import(Module_Globals)
import(Module_Helpers)
import(Module_Level)
import(Module_Map)
import(Module_MapWho)
import(Module_Objects)
import(Module_Person)
import(Module_Players)
import(Module_PopScript)
import(Module_System)
import(Module_Sound)
import(Module_Table)

Swampy = {tribe = 0}
Swampy.__index = Swampy

function Swampy:new(o, tribe, c3dLocation)
	local o = o or {}
	setmetatable(o, Swampy)

	o.tribe = tribe
	o.c3dLocation = c3dLocation
	o.initialized = 0
	o.myTiles = {}
	o.decorations = {}
	o.myLocation = Coord3D.new()

	--Have to put a reference of a reference into the actual myLocation otherwise it gets edited and swamp randomly kills itself due to shamans respawning "near it".
	--Apparently if the Xpos or other position from a Coord changes the one that has its reference ALSO changes.
	local dumbassPosX = c3dLocation.Xpos
	o.myLocation.Xpos = dumbassPosX
	local dumbassPosY = c3dLocation.Ypos
	o.myLocation.Ypos = dumbassPosY
	local dumbassPosZ = c3dLocation.Zpos
	o.myLocation.Zpos = dumbassPosZ

	o.maxTime = 2160
	o.maxKills = 10
	
	o.currentTime = 0
	o.currentKills = 0

	--o.numTilesDisabled = 0

	return o
end

function Swampy:deleteMe()
	DeleteSwampFromList(self)
	for i, tile in pairs(self.myTiles) do
		if (tile ~= nil) then
			DestroyThing(tile)
		end
	end

	for i, deco in pairs(self.decorations) do
		DestroyThing(deco)
	end
end

function Swampy:handleSwampy()
	if (self.initialized == 0) then

		for i=1, 9 do
			placeLocation = Coord3D.new()
			placeLocation = self.c3dLocation

			--Place mist
			if (i == 2) then
				placeLocation.Zpos = placeLocation.Zpos - 512
			elseif (i == 3) then
				placeLocation.Xpos = placeLocation.Xpos + 512
			elseif (i == 4) then
				placeLocation.Zpos = placeLocation.Zpos + 512
			elseif (i == 5) then
				placeLocation.Zpos = placeLocation.Zpos + 512
			elseif (i == 6) then
				placeLocation.Xpos = placeLocation.Xpos - 512
			elseif (i == 7) then
				placeLocation.Xpos = placeLocation.Xpos - 512
			elseif (i == 8) then
				placeLocation.Zpos = placeLocation.Zpos - 512
			elseif (i == 9) then
				placeLocation.Zpos = placeLocation.Zpos - 512
			end

			SearchMapCells(CIRCULAR, 0, 0, 0, world_coord3d_to_map_idx(self.c3dLocation), function(me)
          if (is_map_elem_all_sea(me) > 0) then
							
					else
						ensure_point_on_ground(placeLocation)
						local swampTile = createThing(T_EFFECT, M_EFFECT_SWAMP_MIST, self.tribe, placeLocation, false, false)
						table.insert(self.myTiles, swampTile)
						local decorationMist = createThing(T_EFFECT, M_EFFECT_SWAMP_MIST, self.tribe, placeLocation, false, false)
						table.insert(self.decorations, decorationMist)

						--Place plants
						local plantLocation = Coord3D.new()
						plantLocation = self.c3dLocation

						local locationOffset = G_RANDOM(150) - G_RANDOM(150)
						if (i == 2) then
							plantLocation.Xpos = plantLocation.Xpos + locationOffset
							local plantDecoration = createThing(T_EFFECT, M_EFFECT_REEDY_GRASS, self.tribe, placeLocation, false, false)
							table.insert(self.decorations, plantDecoration)
							plantLocation.Xpos = plantLocation.Xpos - locationOffset
						elseif (i == 4) then
							plantLocation.Xpos = plantLocation.Xpos + locationOffset
							local plantDecoration = createThing(T_EFFECT, M_EFFECT_REEDY_GRASS, self.tribe, placeLocation, false, false)
							table.insert(self.decorations, plantDecoration)
							plantLocation.Xpos = plantLocation.Xpos - locationOffset
						elseif (i == 6) then
							plantLocation.Xpos = plantLocation.Xpos + locationOffset
							local plantDecoration = createThing(T_EFFECT, M_EFFECT_REEDY_GRASS, self.tribe, placeLocation, false, false)
							table.insert(self.decorations, plantDecoration)
							plantLocation.Xpos = plantLocation.Xpos - locationOffset
						elseif (i == 8) then
							plantLocation.Xpos = plantLocation.Xpos + locationOffset
							local plantDecoration = createThing(T_EFFECT, M_EFFECT_REEDY_GRASS, self.tribe, placeLocation, false, false)
							table.insert(self.decorations, plantDecoration)
							plantLocation.Xpos = plantLocation.Xpos - locationOffset
						end
					end
					return true
					end)
		end
		queue_sound_event(self.myTiles[1], SND_EVENT_SP_SWAMP, SEF_LOOPED)

		self.initialized = 1
	end

	if (everyPow(3, 1)) then
		local unitsDamaged = 0

		for i, tile in pairs(self.myTiles) do
			if (tile ~= nil) then
				SearchMapCells(CIRCULAR, 0, 0, 0, world_coord3d_to_map_idx(tile.Pos.D3), function(me)
					me.MapWhoList:processList(function(p)
						if (p.Type == T_PERSON and is_thing_on_ground(p) == 1 and unitsDamaged < 10 and p.Owner ~= TRIBE_NEUTRAL) then
							--self.myTiles[i] = nil

							--if (p.Flags2 & TF2_THING_IS_A_GHOST_PERSON == 0) then
							--	DestroyThing(tile)
							--end
							
							--self.numTilesDisabled = self.numTilesDisabled + 1
							p.u.Pers.u.Owned.LastDamagedBy = tile.Owner
							p.u.Pers.Life = p.u.Pers.Life - 350
							unitsDamaged = unitsDamaged + 1

							if (p.u.Pers.Life <= 0 and p.Flags2 & TF2_THING_IS_A_GHOST_PERSON == 0) then
								if (p.Model == M_PERSON_MEDICINE_MAN and p.Owner ~= tile.Owner) then
									SetShamanSwampDeath(p)
								end
								self.currentKills = self.currentKills + 1
							end
						end
					return true
					end)
				return true
				end)
			end
		end

		if (self.currentKills >= self.maxKills or self.currentTime >= self.maxTime) then
			self:deleteMe()
		end
	end

	self.currentTime = self.currentTime + 1
end

Ghosts = {tribe = 0}
Ghosts.__index = Ghosts

function Ghosts:new(o, tribe, maximumGhosts)
	local o = o or {}
	setmetatable(o, Ghosts)

	o.tribe = tribe
	o.maximumGhosts = maximumGhosts

	o.ghostsTable = {}

	return o
end

function Ghosts:addGhost(thing)
	table.insert(self.ghostsTable, thing)
end

function Ghosts:killExcessGhosts()
	for i, ghst in pairs(self.ghostsTable) do
		--First clean up any dead ghosts from the table.
		if (ghst == nil or ghst.u.Pers == nil) then
			table.remove(self.ghostsTable, i)
		end
	end

	if (tableLength(self.ghostsTable) > self.maximumGhosts) then
		local amountToKill = tableLength(self.ghostsTable) - self.maximumGhosts

		for j, g in pairs(self.ghostsTable) do
			if (amountToKill > 0) then
				if (g.u.Pers ~= nil) then
					g.u.Pers.Life = 0
					table.remove(self.ghostsTable, j)
					amountToKill = amountToKill - 1
				end
			else
				break
			end
		end
	end
end