import(Module_Commands)
import(Module_Control)
import(Module_DataTypes)
import(Module_Defines)
import(Module_Draw)
import(Module_Game)
import(Module_GameStates)
import(Module_Globals)
import(Module_Helpers)
import(Module_Level)
import(Module_Map)
import(Module_MapWho)
import(Module_Objects)
import(Module_Person)
import(Module_Players)
import(Module_PopScript)
import(Module_System)
import(Module_Sound)
import(Module_Table)

Tree = {tribe = 0}
Tree.__index = Tree

function Tree:new(o, c2dLocation)
	local o = o or {}
	setmetatable(o, Tree)

	o.c2dLocation = c2dLocation
	--o.myPlant = myPlant
	o.myLocation = Coord2D.new()

	local dumbassPosX = c2dLocation.Xpos
	o.myLocation.Xpos = dumbassPosX
	local dumbassPosZ = c2dLocation.Zpos
	o.myLocation.Zpos = dumbassPosZ


	o.countingRegrow = 0
	o.regrowTimerSec = 0
	o.regrowOnSec = 330
	return o
end

function Tree:deleteMe()
	DeleteTreeFromList(self)
end

function Tree:startRegrowing()
	self.countingRegrow = 1
end

function Tree:showMagic()
	if (everyPow(96, 1)) then
		local c3d = Coord3D.new()
		coord2D_to_coord3D(self.myLocation, c3d)
		createThing(T_EFFECT, M_EFFECT_SPARKLE, TRIBE_NEUTRAL, c3d, false, false)
	end
end

--Call me every second (12 turns) for performance
function Tree:handleTree()
	if (self.countingRegrow == 1) then
		self.regrowTimerSec = self.regrowTimerSec + 1

		local c3d = Coord3D.new()
		coord2D_to_coord3D(self.myLocation, c3d)

		SearchMapCells(CIRCULAR, 0, 0, 0, world_coord3d_to_map_idx(c3d), function(me)
        if (me.Flags & (1<<9) >= 1) then
						self:deleteMe()
						return false
        end
    return true
    end)

		if (self.regrowTimerSec >= self.regrowOnSec) then
			local c3d = Coord3D.new()
			coord2D_to_coord3D(self.myLocation, c3d)
			
			local treeModel = G_RANDOM(6)+1
			local rotation = G_RANDOM(2048)+1

			if (treeModel == 1) then
				local tree = createThing(T_SCENERY, M_SCENERY_TREE_1, TRIBE_NEUTRAL, c3d, false, false)
				tree.u.Scenery.ResourceRemaining = 100
				tree.AngleXZ = rotation
			end
			if (treeModel == 2) then
				local tree = createThing(T_SCENERY, M_SCENERY_TREE_2, TRIBE_NEUTRAL, c3d, false, false)
				tree.u.Scenery.ResourceRemaining = 100
				tree.AngleXZ = rotation
			end
			if (treeModel == 3) then
				local tree = createThing(T_SCENERY, M_SCENERY_TREE_3, TRIBE_NEUTRAL, c3d, false, false)
				tree.u.Scenery.ResourceRemaining = 100
				tree.AngleXZ = rotation
			end
			if (treeModel == 4) then
				local tree = createThing(T_SCENERY, M_SCENERY_TREE_4, TRIBE_NEUTRAL, c3d, false, false)
				tree.u.Scenery.ResourceRemaining = 100
				tree.AngleXZ = rotation
			end
			if (treeModel == 5) then
				local tree = createThing(T_SCENERY, M_SCENERY_TREE_5, TRIBE_NEUTRAL, c3d, false, false)
				tree.u.Scenery.ResourceRemaining = 100
				tree.AngleXZ = rotation
			end
			if (treeModel == 6) then
				local tree = createThing(T_SCENERY, M_SCENERY_TREE_6, TRIBE_NEUTRAL, c3d, false, false)
				tree.u.Scenery.ResourceRemaining = 100
				tree.AngleXZ = rotation
			end

			self.countingRegrow = 0
			self.regrowTimerSec = 0
		end
	end
end