import(Module_Commands)
import(Module_Control)
import(Module_DataTypes)
import(Module_Defines)
import(Module_Draw)
import(Module_Game)
import(Module_GameStates)
import(Module_Globals)
import(Module_Helpers)
import(Module_Level)
import(Module_Map)
import(Module_MapWho)
import(Module_Objects)
import(Module_Person)
import(Module_Players)
import(Module_PopScript)
import(Module_System)
import(Module_Sound)
import(Module_Table)

Vehicle = {tribe = 0}
Vehicle.__index = Vehicle

function Vehicle:new(o, tribe, maxHealth, vehicleThing)
	local o = o or {}
	setmetatable(o, Vehicle)

	o.tribe = tribe
	o.maxHealth = maxHealth
	o.currentHealth = maxHealth
	o.vehicleThing = vehicleThing

	o.fireballsGround = {}
	o.fireballsTower = {}

	o.shamanIsInsideMe = 0
	--o.lastNumOccupants = 0

	return o
end

function Vehicle:handleVehicle()
	if (self.currentHealth <= 0) then
		if (self.vehicleThing ~= nil) then
			self.vehicleThing.u.Vehicle.Life = -1
			self.vehicleThing = nil
			DeleteVehicleFromList(self)
		end
	end

	if (self.shamanIsInsideMe == 1) then
		if (self.vehicleThing.Move.SelfPowerSpeed >= 45) then
			self.vehicleThing.Move.SelfPowerSpeed = 45
		end
	end

	for i, ball in pairs(self.fireballsGround) do
		if (GetTurn() >= ball) then
			self:damageVehicle(50)
			table.remove(self.fireballsGround, i)
		end
	end

	for i, ball in pairs(self.fireballsTower) do
		if (GetTurn() >= ball) then
			self:damageVehicle(175)
			table.remove(self.fireballsTower, i)
		end
	end

	if (self.vehicleThing ~= nil) then
		myOwnersShaman = getShaman(self.vehicleThing.Owner)

		if (myOwnersShaman ~= nil and self.shamanIsInsideMe == 1) then
			if (myOwnersShaman.Flags2 & TF2_IN_AIRSHIP <= 0 and is_person_in_boat(myOwnersShaman) == 0) then
				self:SetShamanInsideMe(0)
			end
		end
	end
	--Check if a shaman is inside me but only do it when the number of occupants has changed since last checking.
	--[[if (self.vehicleThing ~= nil) then
		if (self.vehicleThing.u ~= nil) then
			if (self.vehicleThing.u.Vehicle ~= nil) then
				if (self.vehicleThing.u.Vehicle.NumOccupants < self.lastNumOccupants or self.vehicleThing.u.Vehicle.NumOccupants > self.lastNumOccupants) then
					self.lastNumOccupants = self.vehicleThing.u.Vehicle.NumOccupants
					local foundShaman = 0
					log_msg(TRIBE_NEUTRAL, "NumOccupants Changed")
					SearchMapCells(CIRCULAR, 0, 0, 0, world_coord3d_to_map_idx(self.vehicleThing.Pos.D3), function(me)
						me.MapWhoList:processList(function(p)
							if (p.Type == T_PERSON) then
								log_msg(TRIBE_NEUTRAL, "Person "..p.Model)
								if (p.Model == M_PERSON_MEDICINE_MAN) then  
									self.shamanIsInsideMe = 1    
									log_msg(TRIBE_NEUTRAL, "Shaman Inside")
									foundShaman = 1
								end
							end
						return true
						end)
					return true
					end)

					if (foundShaman == 0) then
						self.shamanIsInsideMe = 0
						log_msg(TRIBE_NEUTRAL, "Shaman Outside")
					end
				end
			end
		end
	end--]]

	if (everyPow(12, 1)) then
		if (self.currentHealth <= self.maxHealth) then
			self.currentHealth = self.currentHealth + 32
		end
	end
end

function Vehicle:SetShamanInsideMe(shamanInside)
	self.shamanIsInsideMe = shamanInside
end

function Vehicle:AddFireball(turn, tower)
	if (tower == 1) then
		table.insert(self.fireballsTower, turn)
	else
		table.insert(self.fireballsGround, turn)
	end
end

function Vehicle:damageVehicle(dmg)
	self.currentHealth = self.currentHealth - dmg
end

function Vehicle:getVehicleByPosition(D2Pos)
	if (self.vehicleThing ~= nil) then
		local c2d = Coord2D.new()
		coord3D_to_coord2D(self.vehicleThing.Pos.D3, c2d)

		if (get_world_dist_xz(D2Pos, c2d) < 160) then
			return self
		end
	end

	return nil
end